1
0
mirror of git://git.sv.gnu.org/coreutils.git synced 2026-04-21 11:16:16 +02:00

Add a root-only test for today's lib/idcache.c fix.

* tests/ls/nameless-uid: New file.
* tests/ls/Makefile.am (TESTS): Add nameless-uid.
(TESTS_ENVIRONMENT): Add PERL to the list.
This commit is contained in:
Jim Meyering
2006-11-20 11:31:05 +01:00
parent 81ebd46046
commit 279c41d79c
3 changed files with 74 additions and 0 deletions

View File

@@ -21,6 +21,7 @@
AUTOMAKE_OPTIONS = 1.2 gnits
TESTS = \
nameless-uid \
color-dtype-dir \
stat-failed \
stat-dtype \
@@ -33,4 +34,5 @@ TESTS_ENVIRONMENT = \
top_srcdir=$(top_srcdir) \
srcdir=$(srcdir) \
PATH="$(VG_PATH_PREFIX)`pwd`/../../src$(PATH_SEPARATOR)$$PATH" \
PERL="$(PERL)" \
PROG=ls

65
tests/ls/nameless-uid Executable file
View File

@@ -0,0 +1,65 @@
#!/bin/sh
# Ensure that ls -l works on files with nameless uid and/or gid
# Copyright (C) 2006 Free Software Foundation, Inc.
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
if test "$VERBOSE" = yes; then
set -x
ls --version
fi
. $srcdir/../envvar-check
. $srcdir/../lang-default
PRIV_CHECK_ARG=require-root . $srcdir/../priv-check
$PERL -e 1 > /dev/null 2>&1 || {
echo 1>&2 "$0: configure didn't find a usable version of Perl," \
"so can't run this test"
(exit 77); exit 77
}
nameless_uid=`$PERL -e 'foreach my $i (1000..16*1024) { getpwuid $i or (print "$i\n"), exit }'`
if test x$nameless_uid = x; then
echo "$0: couldn't find a nameless UID" 1>&2
(exit 77); exit 77
fi
pwd=`pwd`
t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
trap '(exit $?); exit $?' 1 2 13 15
framework_failure=0
mkdir -p $tmp || framework_failure=1
cd $tmp || framework_failure=1
touch f || framework_failure=1
chown $nameless_uid f || framework_failure=1
if test $framework_failure = 1; then
echo "$0: failure in testing framework" 1>&2
(exit 1); exit 1
fi
fail=0
set -- `ls -o f` || fail=1
test $3 = $nameless_uid || fail=1
(exit $fail); exit $fail